with GNATCOM.IInterface;

with GNATCOM.Errors;

package body MSHTML.IHTMLStyleSheet3_Interface is

   procedure Initialize (This : in out IHTMLStyleSheet3_Type) is
   begin
      Set_IID (This, IID_IHTMLStyleSheet3);
   end Initialize;

   function Pointer (This : IHTMLStyleSheet3_Type)
     return Pointer_To_IHTMLStyleSheet3
   is
   begin
      return To_Pointer_To_IHTMLStyleSheet3 (Address (This));
   end Pointer;

   procedure Attach (This    : in out IHTMLStyleSheet3_Type;
                     Pointer : in     Pointer_To_IHTMLStyleSheet3)
   is
   begin
      Attach (This, GNATCOM.IInterface.To_Pointer_To_IUnknown
              (Pointer.all'Address));
   end Attach;

   procedure Put_href
     (This : IHTMLStyleSheet3_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_href
         (Pointer (This),
          p));

      if Free then
               GNATCOM.IInterface.Free (p);
      
      end if;

   end Put_href;

   function Get_href
     (This : IHTMLStyleSheet3_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_href
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_href;

   function Get_isAlternate
     (This : IHTMLStyleSheet3_Type)
     return GNATCOM.Types.VARIANT_BOOL
   is
       RetVal : aliased GNATCOM.Types.VARIANT_BOOL;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_isAlternate
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_isAlternate;

   function Get_isPrefAlternate
     (This : IHTMLStyleSheet3_Type)
     return GNATCOM.Types.VARIANT_BOOL
   is
       RetVal : aliased GNATCOM.Types.VARIANT_BOOL;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_isPrefAlternate
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_isPrefAlternate;

end MSHTML.IHTMLStyleSheet3_Interface;

